From c0faaf6cda0e00f831a681d6b1f2bdd1f4599e9c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:17 +0000
Subject: [PATCH 438/2232] Update cxx vector check to match rust vec check


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 9683224..090a9ae 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -126,18 +126,19 @@ fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
 fn check_type_cxx_vector(cx: &mut Check, ptr: &Ty1) {
     if let Type::Ident(ident) = &ptr.inner {
         if cx.types.rust.contains(ident) {
-            cx.error(ptr, "vector of a Rust type is not supported yet");
+            cx.error(
+                ptr,
+                "C++ vector containing a Rust type is not supported yet",
+            );
         }
 
         match Atom::from(ident) {
+            Some(atom) if is_valid_vector_element(atom) => return,
             None => return,
-            Some(atom) => {
-                if is_valid_vector_element(atom) {
-                    return;
-                }
-            }
+            _ => {}
         }
     }
+
     cx.error(ptr, "unsupported vector target type");
 }
 

